﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Diagnostics;

namespace Roborace
{
    public partial class Form1 : Form
    {
        private int IdHry = 0;
        private string[] Mapa = new string[20];
        char[] MozneTahy = new char[9];
        private Point Souradnice = new Point(0, 0);
        private char Smer = 'N';

        int kolo = 1;
        int vpred = 0;
        int vpred2 = 0;
        int vpred3 = 0;
        int vpravo = 0;
        int vlevo = 0;
        int vzad = 0;
        private List<char> vybranePohyby = new List<char>();


        public Form1()
        {
            InitializeComponent();
        }

        private bool IsValidBlock(char c)
        {
            // vrací true, je li předaný znak validním blokem mapy
            if (c == '.' || c == '#' || c == '$' || c == 'X')
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        private bool IsValidMove(char c)
        {
            // vrací true, je li předaný znak validním zástupcem pohybu
            if (c == '1' || c == '2' || c == '3' || c == 'L' || c == 'R' || c == 'Z')
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        private void ZpracujOdpoved(Stream str)
        {
            StreamReader reader = new StreamReader(str);
            int radek = 0;
            string buff = "";
            
            // zpracování odpovědi ze serveru
            while (reader.EndOfStream == false)
            {
                buff = reader.ReadLine();
                if (radek == 0)
                {
                    // řádek 0 - id hry
                    int cislo = 0;
                    try
                    {
                        Int32.TryParse(buff, out cislo);
                        IdHry = cislo;
                    }
                    catch
                    {
                        MessageBox.Show("Chyba získávání čísla hry: " + buff);
                        return;
                    }
                }
                else if (radek == 21)
                {
                    // řádek 22 - souřadnice a orientace robota
                    string[] pozice = buff.Split(' ');
                    if (pozice.Length != 3)
                    {
                        MessageBox.Show("Chyba získávání aktuální orientace robota E1: " + buff);
                        return;
                    }
                    else
                    {
                        int x = 0;
                        int y = 0;
                        char smer = 'N';

                        try
                        {
                            Int32.TryParse(pozice[0], out x);
                            Int32.TryParse(pozice[1], out y);
                            Smer = pozice[2][0];
                            Souradnice.X = x;
                            Souradnice.Y = y;
                        }
                        catch
                        {
                            MessageBox.Show("Chyba získávání aktuální orientace robota E2");
                            return;
                        }
                    }
                }
                else if (radek == 22)
                {
                    // řádek 23 - nabídka pohybů pro uživatele
                    for (int i = 0; i < 9; i++)
                    {
                        if (IsValidMove(buff[i]))
                        {
                            MozneTahy[i] = buff[i];
                            char tah = buff[i];
                            if (tah == '1')
                            {
                                vpred++;
                            }
                            if (tah == '2')
                            {
                                vpred2++;
                            }
                            if (tah == '3')
                            {
                                vpred3++;
                            }
                            if (tah == 'R')
                            {
                                vpravo++;
                            }
                            if (tah == 'L')
                            {
                                vlevo++;
                            }
                            if (tah == 'Z')
                            {
                                vzad++;
                            }
                        }
                    }
                }
                else
                {
                    for (int i = 0; i < 20; i++)
                    {
                        if (IsValidBlock(buff[i]))
                        {
                            Mapa[radek - 1] += buff[i];
                        }
                        else
                        {
                            MessageBox.Show("E3 - "+buff[i]);
                            Application.Exit();
                        }
                    }
                }

                radek++;
            }

        }

        private void AktualizujUI()
        {

            #region Vykreslení mapy do textboxu

            Graphics g = panel1.CreateGraphics();
            for (int r = 0; r < 20; r++)
            {
                for (int s = 0; s < 20; s++)
                {
                    int y = 5 + (r * 30);
                    int w = 30;
                    int h = 30;
                    int x = 5 + (s * 30);

                    char policko = Mapa[r][s];
                    if (policko == 'X')
                    {
                        g.FillRectangle(Brushes.Gray, x, y, w, h);
                    }
                    else if (policko == '#')
                    {
                        g.FillRectangle(Brushes.Red, x, y, w, h);
                    }
                    else if (policko == '$')
                    {
                        g.FillRectangle(Brushes.Gold, x, y, w, h);
                    }
                    else
                    {
                        g.DrawRectangle(Pens.Black, x, y, w, h);
                    }
                }
            }

            Bitmap b = Roborace.Properties.Resources.robotn;
            if (Smer == 'D') { b = Roborace.Properties.Resources.robotd; }
            else if (Smer == 'L') { b = Roborace.Properties.Resources.robotl; }
            else if (Smer == 'R') { b = Roborace.Properties.Resources.robotr; }

            g.DrawImage(b, 5 + ((Souradnice.X - 1) * 30), 5 + ((Souradnice.Y - 1) * 30));

            #endregion

        }

        private void novahra_Click(object sender, EventArgs e)
        {
            Uri adresa = new Uri("http://" + adresaServeru.Text + ":" + portServeru.Text + "/start");
            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(adresa);
            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream respStream = resp.GetResponseStream();

            ZpracujOdpoved(respStream);
            AktualizujUI();

            novahra.Enabled = adresaServeru.Enabled = portServeru.Enabled = false;


        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (listBox1.Items.Count == 5 || vpred == 0) { return; }
            vybranePohyby.Add('1');
            listBox1.Items.Add("Krok vpřed");
            vpred--;
            if (vpred == 0) {
                button1.Enabled = false;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (listBox1.Items.Count == 5 || vpred2 == 0) { return; }
            vybranePohyby.Add('2');
            listBox1.Items.Add("2 Kroky vpřed");
            vpred2--;
            if (vpred2 == 0) {
                button2.Enabled = false;
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (listBox1.Items.Count == 5 || vpred3 == 0) { return; }
            vybranePohyby.Add('3');
            listBox1.Items.Add("3 Kroky vpřed");
            vpred3--;
            if (vpred3 == 0)
            {
                button3.Enabled = false;
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            if (listBox1.Items.Count == 5 || vlevo == 0) { return; }
            vybranePohyby.Add('L');
            listBox1.Items.Add("90° Doleva");
            vlevo--;
            if (vlevo == 0)
            {
                button4.Enabled = false;
            }
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (listBox1.Items.Count == 5 || vpravo == 0) { return; }
            vybranePohyby.Add('R');
            listBox1.Items.Add("90° Vpravo");
            vpravo--;
            if (vpravo == 0)
            {
                button6.Enabled = false;
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (listBox1.Items.Count == 5 || vzad == 0) { return; }
            vybranePohyby.Add('Z');
            listBox1.Items.Add("Krok vzad");
            vzad--;
            if (vzad == 0)
            {
                button5.Enabled = false;
            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            button1.Enabled = button2.Enabled = button3.Enabled = button4.Enabled = button5.Enabled = button6.Enabled = true;
            foreach (string item in listBox1.Items)
            {
                if (item == "Krok vpřed") { vpred++; }
                if (item == "2 Kroky vpřed") { vpred2++; }
                if (item == "3 Kroky vpřed") { vpred3++; }
                if (item == "Krok vzad") { vzad++; }
                if (item == "90° Vpravo") { vpravo++; }
                if (item == "90° Doleva") { vlevo++; }
            }
            listBox1.Items.Clear();
        }

        private void button8_Click(object sender, EventArgs e)
        {
            MessageBox.Show("tohle neumím.");
        }

        
        

        

    }
}
